---
title: Delete rows
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Reference Tables
---

# Delete rows{% #delete-rows %}

{% tab title="v2" %}

| Datadog site      | API endpoint                                                                  |
| ----------------- | ----------------------------------------------------------------------------- |
| ap1.datadoghq.com | DELETE https://api.ap1.datadoghq.com/api/v2/reference-tables/tables/{id}/rows |
| ap2.datadoghq.com | DELETE https://api.ap2.datadoghq.com/api/v2/reference-tables/tables/{id}/rows |
| app.datadoghq.eu  | DELETE https://api.datadoghq.eu/api/v2/reference-tables/tables/{id}/rows      |
| app.ddog-gov.com  | DELETE https://api.ddog-gov.com/api/v2/reference-tables/tables/{id}/rows      |
| us2.ddog-gov.com  | DELETE https://api.us2.ddog-gov.com/api/v2/reference-tables/tables/{id}/rows  |
| app.datadoghq.com | DELETE https://api.datadoghq.com/api/v2/reference-tables/tables/{id}/rows     |
| us3.datadoghq.com | DELETE https://api.us3.datadoghq.com/api/v2/reference-tables/tables/{id}/rows |
| us5.datadoghq.com | DELETE https://api.us5.datadoghq.com/api/v2/reference-tables/tables/{id}/rows |

### Overview

Delete multiple rows from a Reference Table by their primary key values.

### Arguments

#### Path Parameters

| Name                 | Type   | Description                                                  |
| -------------------- | ------ | ------------------------------------------------------------ |
| id [*required*] | string | Unique identifier of the reference table to delete rows from |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                  | Type     | Description                                                       |
| ------------ | ---------------------- | -------- | ----------------------------------------------------------------- |
|              | data [*required*] | [object] | List of row resources to delete from the reference table.         |
| data         | id [*required*]   | string   | The primary key value that uniquely identifies the row to delete. |
| data         | type [*required*] | enum     | Row resource type. Allowed enum values: `row`                     |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": [
    {
      "id": "primary_key_value",
      "type": "row"
    }
  ]
}
```

{% /tab %}

### Response

{% tab title="200" %}
Rows deleted successfully
{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="500" %}
Internal Server Error
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export id="CHANGE_ME" \# Curl command curl -X DELETE "https://api.datadoghq.com/api/v2/reference-tables/tables/${id}/rows" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": [
    {
      "id": "primary_key_value",
      "type": "row"
    }
  ]
}
EOF 
                
##### 

```python
"""
Delete rows returns "Rows deleted successfully" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.reference_tables_api import ReferenceTablesApi
from datadog_api_client.v2.model.batch_delete_rows_request_array import BatchDeleteRowsRequestArray
from datadog_api_client.v2.model.table_row_resource_data_type import TableRowResourceDataType
from datadog_api_client.v2.model.table_row_resource_identifier import TableRowResourceIdentifier

body = BatchDeleteRowsRequestArray(
    data=[
        TableRowResourceIdentifier(
            id="primary_key_value",
            type=TableRowResourceDataType.ROW,
        ),
    ],
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = ReferenceTablesApi(api_client)
    api_instance.delete_rows(id="id", body=body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Delete rows returns "Rows deleted successfully" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::ReferenceTablesAPI.new

body = DatadogAPIClient::V2::BatchDeleteRowsRequestArray.new({
  data: [
    DatadogAPIClient::V2::TableRowResourceIdentifier.new({
      id: "primary_key_value",
      type: DatadogAPIClient::V2::TableRowResourceDataType::ROW,
    }),
  ],
})
p api_instance.delete_rows("id", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Delete rows returns "Rows deleted successfully" response

package main

import (
	"context"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.BatchDeleteRowsRequestArray{
		Data: []datadogV2.TableRowResourceIdentifier{
			{
				Id:   "primary_key_value",
				Type: datadogV2.TABLEROWRESOURCEDATATYPE_ROW,
			},
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewReferenceTablesApi(apiClient)
	r, err := api.DeleteRows(ctx, "id", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `ReferenceTablesApi.DeleteRows`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Delete rows returns "Rows deleted successfully" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.ReferenceTablesApi;
import com.datadog.api.client.v2.model.BatchDeleteRowsRequestArray;
import com.datadog.api.client.v2.model.TableRowResourceDataType;
import com.datadog.api.client.v2.model.TableRowResourceIdentifier;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    ReferenceTablesApi apiInstance = new ReferenceTablesApi(defaultClient);

    BatchDeleteRowsRequestArray body =
        new BatchDeleteRowsRequestArray()
            .data(
                Collections.singletonList(
                    new TableRowResourceIdentifier()
                        .id("primary_key_value")
                        .type(TableRowResourceDataType.ROW)));

    try {
      apiInstance.deleteRows("id", body);
    } catch (ApiException e) {
      System.err.println("Exception when calling ReferenceTablesApi#deleteRows");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Delete rows returns "Rows deleted successfully" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_reference_tables::ReferenceTablesAPI;
use datadog_api_client::datadogV2::model::BatchDeleteRowsRequestArray;
use datadog_api_client::datadogV2::model::TableRowResourceDataType;
use datadog_api_client::datadogV2::model::TableRowResourceIdentifier;

#[tokio::main]
async fn main() {
    let body = BatchDeleteRowsRequestArray::new(vec![TableRowResourceIdentifier::new(
        "primary_key_value".to_string(),
        TableRowResourceDataType::ROW,
    )]);
    let configuration = datadog::Configuration::new();
    let api = ReferenceTablesAPI::with_config(configuration);
    let resp = api.delete_rows("id".to_string(), body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Delete rows returns "Rows deleted successfully" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.ReferenceTablesApi(configuration);

const params: v2.ReferenceTablesApiDeleteRowsRequest = {
  body: {
    data: [
      {
        id: "primary_key_value",
        type: "row",
      },
    ],
  },
  id: "id",
};

apiInstance
  .deleteRows(params)
  .then((data: any) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
